/****************************************/
/* MES/Copyleft Yukio Mituiwa,2005	*/
/*					*/
/*  2005/2/14 first release		*/
/*					*/
/****************************************/
#include <string.h>
#include "mes.h"

extern char _user;

void load_disk(void) {
	volatile unsigned char *ptr;
	char	name[64];
	int	fd, size, n;

	mount("ram0");
	ptr = &_user;
#if defined(__arm__)
	ptr = &ptr[0x300000];
#endif
	while(ptr[0] != 0xff) {
		n = strlen((char*)ptr);
		strcpy(name, "/ram0/");
		strcat(name, (char*)ptr);
		ptr = &ptr[n + 1];
		size = ptr[0];
		size += ptr[1] << 8;
		size += ptr[2] << 16;
		size += ptr[3] << 24;
		ptr = &ptr[4];
		fd = __open(SuperTask, name, OptWrite);
		__write(SuperTask, fd, (char*)ptr, size);
		__close(SuperTask, fd);
		ptr = &ptr[size];
	}
}

char *get_romconfig(int *len, char *name) {
	volatile unsigned char	*ptr;
	char		*filename;
	int		size, n;

	ptr = &_user;
#if defined(__arm__)
	ptr = &ptr[0x300000];
#endif
	while(ptr[0] != 0xff) {
		filename = (char*)ptr;
		n = strlen((char*)ptr);
		ptr = &ptr[n + 1];
		size = ptr[0];
		size += ptr[1] << 8;
		size += ptr[2] << 16;
		size += ptr[3] << 24;
		ptr = &ptr[4];
		if(strcmp(filename, name) == 0) {
			*len = size;
			return (char*)ptr;
		}
		ptr = &ptr[size];
	}
	return 0;
}
