#include "mes.h"

#define REGSIZ	1024

typedef struct {
	char	name[8];
	char	data[24];
} __attribute__ ((packed)) Regist;

static Regist *root;

int set_regist(int op, char *name, char *str) {
	int	*max, *nmax, *pmax, *ptr, i, n, new, data, count, reqsiz, index, size;
	char	buf[9], flag;
	Regist	*regist, *next, *prev;

	regist = root;
	max = (int*)regist;
	flag = 0;
	for(i = 1;;i++) {
		if(i == *max) {
			if(max[1] == 0) break;
			regist = (Regist*)max[1];
			max = (int*)regist;
			i = 1;
		}
		ptr = (int*)regist[i].name;
		if(*ptr == -1) {
			if(flag == 0) continue;
			bzero((char*)&regist[i], sizeof(Regist));
		} else {
			if(flag == 1) {
				if(op == REGIST_STRING && str == 0) return 0;
				break;
			}
		}
		buf[8] = 0;
		memcpy(buf, regist[i].name, 8);
		if(strcmp(buf, name) == 0) {
			bzero((char*)&regist[i], sizeof(Regist));
			flag = 1;
		}
	}
	if(op == REGIST_STRING && str == 0) return -1;

	if(op == REGIST_STRING) {
		reqsiz = (strlen(str) / 24) + 1;
	} else if(op == REGIST_DATA) {
		reqsiz = 1;
	} else {
		return -1;
	}
	regist = root;
	max = (int*)regist;
	count = 0;
	new = 0;
	for(i = 1;;i++) {
		if(i == *max) {
			if(max[1] == 0) break;
			regist = (Regist*)max[1];
			max = (int*)regist;
			i = 1;
		}
		ptr = (int*)regist[i].name;
		if(regist[i].name[0] == 0) {
			if(count == 0) {
				new = i;
				prev = regist;
				pmax = max;
			}
			count++;
		} else {
			count = 0;
		}
		if(count == reqsiz) break;
	}
	n = strlen(name);
	if(n > 8) n = 8;
	max = pmax;
	regist = prev;
	flag = 0;
	index = 0;
	for(i = new;reqsiz > 0;i++, reqsiz--) {
		if(i == *max) {
			if(max[1] == 0) {
				next = (Regist*)__malloc(SuperTask, REGSIZ);
				bzero((char*)next, REGSIZ);
				max[1] = (int)next;
				nmax = (int*)next;
				*nmax = REGSIZ / sizeof(Regist);
			}
			regist = (Regist*)max[1];
			max = (int*)regist;
			i = 1;
		}
		if(regist[i].name[0] == 0) {
			switch(op) {
			case REGIST_STRING:
				if(flag == 0) {
					memcpy(regist[i].name, name, n);
				} else {
					ptr = (int*)regist[i].name;
					*ptr = -1;
				}
				size = strlen(&str[index]);
				if(size > 24) size = 24;
				memcpy(regist[i].data, &str[index], size);
				index += size;
				break;
			case REGIST_DATA:
				memcpy(regist[i].name, name, n);
				ptr = (int*)regist[i].data;
				data = (int)str;
				ptr[0] = 0;
				ptr[1] = -1;
				ptr[2] = data;
				break;
			default:
				return -1;
			}
			flag = 1;
		}
	}
	return (flag == 0) ? -1 : 0;
}

int get_regist(int op, char *name, char *str, int maxsize) {
	int	*max, *ptr, i, data, offset;
	Regist	*regist;
	char	flag, buffer[25];

	regist = root;
	max = (int*)regist;
	flag = 0;
	for(i = 1;;i++) {
		if(i == *max) {
			if(max[1] == 0) break;
			regist = (Regist*)max[1];
			max = (int*)regist;
			i = 1;
		}
		ptr = (int*)regist[i].name;
		if(*ptr == -1) {
			if(flag == 0) continue;
			bzero(buffer, 25);
			memcpy(buffer, regist[i].data, 24);
			if((maxsize - offset - 1) > 0) strncat(str, buffer, maxsize - offset - 1);
			offset += strlen(buffer);
		} else {
			if(flag == 1) break;
		}
		buffer[8] = 0;
		memcpy(buffer, regist[i].name, 8);
		if(strcmp(buffer, name) == 0) {
			ptr = (int*)regist[i].data;
			switch(op) {
			case REGIST_STRING:
				if(ptr[0] == 0 && ptr[1] == -1) return -1;
				offset = 0;
				bzero(buffer, 25);
				memcpy(buffer, regist[i].data, 24);
				strncpy(str, buffer, maxsize - 1);
				offset = strlen(buffer);
				flag = 1;
				break;
			case REGIST_DATA:
				if(ptr[0] != 0 || ptr[1] != -1) return -1;
				data = ptr[2];
				ptr = (int*)str;
				*ptr = data;
				return 0;
			default:
				return -1;
			}
		}
	}
	return (flag == 0) ? -1 : 0;
}

int list_regist(int op, int index, char *name) {
	int	*max, *ptr, i, count;
	char	buffer[9];
	Regist	*regist;

	regist = root;
	max = (int*)regist;
	for(i = 1, count = 0;;i++, count++) {
		if(i == *max) {
			if(max[1] == 0) break;
			regist = (Regist*)max[1];
			max = (int*)regist;
			i = 1;
		}
		if(count == index) {
			ptr = (int*)regist[i].name;
			if(*ptr == -1 || *ptr == 0) return 0;
			bzero(buffer, 9);
			memcpy(buffer, regist[i].name, 8);
			ptr = (int*)regist[i].data;
			switch(op) {
			case REGIST_STRING:
				if(ptr[0] == 0 && ptr[1] == -1) return 0;
				break;
			case REGIST_DATA:
				if(ptr[0] != 0 || ptr[1] != -1) return 0;
				break;
			default:
				return 0;
			}
			strcpy(name, buffer);
			return 1;
		}
	}
	return -1;
}

void init_regist(void) {
	int	*max;

	root = (Regist*)__malloc(SuperTask, REGSIZ);
	bzero((char*)root, REGSIZ);
	max = (int*)root;
	*max = REGSIZ / sizeof(Regist);
}
