/****************************************/
/* MES/Copyleft Yukio Mituiwa,2005	*/
/*					*/
/*  2005/2/14 first release		*/
/*					*/
/****************************************/
#include <macro.h>

void task_sw_trap(void) {
#if defined(__arm__)
	asm("sub r0,r0");
	asm("swi");
#endif
#if defined(__H8300H__)
	asm("mov #0,er0");
	asm("trapa #0");
#endif
#if defined(__sh__)
  #if defined(__sh2__)
	INT_DISABLE();
  #endif
	asm("mov #0,r0");
	asm("trapa #32");
  #if defined(__sh2__)
	INT_ENABLE();
  #endif
#endif
}

int command_trap(int command, int arg1, int arg2, int arg3, int arg4, int arg5, int arg6) {
	int	argv[8], ret;

	argv[0] = arg1;
	argv[1] = arg2;
	argv[2] = arg3;
	argv[3] = arg4;
	argv[4] = arg5;
	argv[5] = arg6;
	argv[6] = 0;
	argv[7] = 0;
#if defined(__arm__)
	asm("mov r0,%0" :: "r" (command));
	asm("mov r1,%0" :: "r" (argv));
	asm("swi");
	asm("mov %0,r0" : "=r" (ret));
#endif
#if defined(__H8300H__)
	asm("mov %0,er0" :: "r" (command));
	asm("mov %0,er1" :: "r" (argv));
	asm("trapa #0");
	asm("mov er0,%0" : "=r" (ret));
#endif
#if defined(__sh__)
  #if defined(__sh2__)
	INT_DISABLE();
  #endif
	asm("mov %0,r0" :: "r" (command));
	asm("mov %0,r1" :: "r" (argv));
	asm("trapa #32");
	asm("mov r0,%0" : "=r" (ret));
  #if defined(__sh2__)
	INT_ENABLE();
  #endif
#endif
	return ret;
}
